VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ClsListViewOp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'ClsListViewOp
'
Friend Function ListItemAddDelWithCheck(op As Long, rList As ListView, rNodex As Node, rTreeOp As ClsNodeDoc) As Boolean
'Public Const gcAdd
'Public Const gcDel
On Error GoTo errop
    Dim item As ListItem
    ListItemAddDelWithCheck = False
    Set item = ListViewItemFindByKey(rList, rNodex.Key)
    Select Case op
    Case gcAdd
        If item Is Nothing Then
            ListItemAddDelWithCheck = ListItemAdd(rList, rNodex, rTreeOp)
        End If
    Case gcDel
        If Not item Is Nothing Then
            rList.ListItems.Remove item.index
            ListItemAddDelWithCheck = True
        End If
    End Select
Exit Function
errop:
    Exit Function
End Function
'
Friend Sub ListItemDelIfNodeNothing(rList As ListView, rTreeNodes As Nodes)
    Dim a As Long
    With rList.ListItems
        For a = .count To 1 Step -1
            If FindNodeFromKey(rTreeNodes, .item(a).Key) Is Nothing Then .Remove a
        Next
    End With
End Sub
'
Friend Function ListItemGetFromNodeFullPath(rList As ListView, rFullPath As String) As ListItem
    Dim mItem As ListItem, a As Long
    Set ListItemGetFromNodeFullPath = Nothing
    For a = 1 To rList.ListItems.count
        Set mItem = rList.ListItems(a)
        If mItem.SubItems(1) = rFullPath Then
            Set ListItemGetFromNodeFullPath = mItem
            Exit Function
        End If
    Next
End Function
'
Friend Function ListItemSelectFromNodeFullPath(rList As ListView, rFullPath As String) As ListItem
    Dim mItem As ListItem, a As Long
    Set ListItemSelectFromNodeFullPath = Nothing
    For a = 1 To rList.ListItems.count
        Set mItem = rList.ListItems(a)
        If mItem.SubItems(1) = rFullPath Then
            Set rList.SelectedItem = mItem
            mItem.EnsureVisible
            Set ListItemSelectFromNodeFullPath = mItem
            Exit Function
        End If
    Next
End Function
'
Friend Function NodeGetFromListViewSelectedItem(rList As ListView, rTreeNodes As Nodes, Optional SelectIfNotFind As Boolean = False) As Node
    Dim mItem As ListItem
    Set mItem = ListViewSelectedItem(rList)
    If mItem Is Nothing Then
        If SelectIfNotFind And rList.ListItems.count > 0 Then
            Set rList.SelectedItem = rList.ListItems(1)
            rList.Refresh
            Set mItem = rList.SelectedItem
        End If
    End If
    Set NodeGetFromListViewSelectedItem = zFindNodeFromItem(rTreeNodes, mItem)
End Function
'
Friend Function ListViewCurrentItemFullPath(rList As ListView) As String
    Dim mItem As ListItem
    Set mItem = ListViewSelectedItem(rList)
    If (Not mItem Is Nothing) Then ListViewCurrentItemFullPath = mItem.SubItems(1) Else ListViewCurrentItemFullPath = ""
End Function
'
Friend Function ListViewCurrentItemKey(rList As ListView) As String
    Dim mItem As ListItem
    Set mItem = ListViewSelectedItem(rList)
    If (Not mItem Is Nothing) Then ListViewCurrentItemKey = mItem.Key Else ListViewCurrentItemKey = ""
End Function
'
Friend Function ListItemNodeSetNewTitlePath(rList As ListView, rNodex As Node) As Boolean
    Dim a As Long, mItem As ListItem
    ListItemNodeSetNewTitlePath = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = zFindItemFromNodeKey(rList, rNodex)
    If mItem Is Nothing Then Exit Function
    With mItem
        .Text = rNodex.Text
        .SubItems(1) = rNodex.FullPath
'        .SubItems(4) = rTagOp.TimeChange(rNodex.tag) '2002-0925@'^CgݒŕύXԂςׂ@?????????????
    End With
    ListItemNodeSetNewTitlePath = True
End Function
'
Friend Function ListItemIconChange(rList As ListView, rNodex As Node) As Boolean
    Dim mItem As ListItem, mFindItem As ListItem, oldItem As ListItem, wTimeStr As String
    ListItemIconChange = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = zFindItemFromNodeKey(rList, rNodex)
    If mItem Is Nothing Then Exit Function
    mItem.SmallIcon = rNodex.Image
    ListItemIconChange = True
End Function
'
Friend Function ListItemDataChange(rList As ListView, rNodex As Node, rTreeOp As ClsNodeDoc) As Boolean
    Dim mItem As ListItem
    ListItemDataChange = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = zFindItemFromNodeKey(rList, rNodex)
    If mItem Is Nothing Then Exit Function
    If False = zItemDataSet(rList, mItem, rNodex, "", "", rTreeOp) Then Exit Function
    ListItemDataChange = True
End Function
'
Friend Function ListItemAdd(rList As ListView, rNodex As Node, rTreeOp As ClsNodeDoc, Optional AddCountInLast As Boolean = False) As Boolean
    Dim mItem As ListItem
    ListItemAdd = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = rList.ListItems.add
    If False = zItemDataSet(rList, mItem, rNodex, "", "", rTreeOp, AddCountInLast) Then
        rList.ListItems.Remove mItem.index
        Exit Function
    End If
    ListItemAdd = True
End Function
'
Friend Function ListItemAddByTagFullPath(rList As ListView, rTag As String, rFullPath As String, rTreeOp As ClsNodeDoc, Optional AddCountInLast As Boolean = False) As Boolean
    Dim mItem As ListItem
    ListItemAddByTagFullPath = False
    Set mItem = rList.ListItems.add
    If False = zItemDataSet(rList, mItem, Nothing, rTag, rFullPath, rTreeOp, AddCountInLast) Then
        rList.ListItems.Remove mItem.index
        Exit Function
    End If
    ListItemAddByTagFullPath = True
End Function
'
Friend Sub LoadBookAllMemoItem(rList As ListView, rTreeNodes As Nodes, rBook As Node, rTreeOp As ClsNodeDoc)
    Dim a As Long, nodex As Node
    rList.ListItems.Clear
    For a = 1 To rTreeNodes.count
        Set nodex = TopNodeFromDescendantNode(rTreeNodes(a))
        If nodex Is rBook Then Call ListItemAdd(rList, rTreeNodes(a), rTreeOp)
    Next
End Sub
'
Private Function zFindNodeFromItem(rTreeNodes As Nodes, rItem As ListItem) As Node
On Error GoTo errop
    Set zFindNodeFromItem = rTreeNodes(rItem.Key)
Exit Function
errop:
    Set zFindNodeFromItem = Nothing
    Exit Function
End Function
'
Private Function zFindItemFromNodeKey(rList As ListView, rNodex As Node) As ListItem
On Error GoTo errop
    Set zFindItemFromNodeKey = rList.ListItems(rNodex.Key)
Exit Function
errop:
    Set zFindItemFromNodeKey = Nothing
    Exit Function
End Function
'
Private Function zItemDataSet(rList As ListView, mItem As ListItem, rNodex As Node, rTag As String, rFullPath As String, rTreeOp As ClsNodeDoc, Optional AddCountInLast As Boolean = False) As Boolean
On Error GoTo errop
    Dim ret As Long, wFileType As String, wFileSize As Long
    zItemDataSet = False
    If rNodex Is Nothing Then
        Call rTreeOp.MemoFileTypeFileSize(rTag, rFullPath, "", wFileType, wFileSize)
        With mItem
            .Text = rTreeOp.MemoTitleFromFullPath(rFullPath)
'            .SmallIcon
            .SubItems(1) = rFullPath
            .SubItems(2) = wFileType
            .SubItems(3) = gFormatExAddHedSpace(wFileSize)
            .SubItems(4) = rTreeOp.TimeChange(rTag)
            If AddCountInLast Then .SubItems(5) = Format$(rList.ListItems.count, "00000")
'            .key = rNodex.key
'            .tag = rNodex.key
        End With
    Else
        Call rTreeOp.MemoFileTypeFileSize(rNodex.Tag, rNodex.FullPath, rNodex.Key, wFileType, wFileSize)
        With mItem
            .Text = rNodex.Text
            .SmallIcon = rNodex.Image
            .SubItems(1) = rNodex.FullPath
            .SubItems(2) = wFileType
            .SubItems(3) = gFormatExAddHedSpace(wFileSize)
            .SubItems(4) = rTreeOp.TimeChange(rNodex.Tag)
            If AddCountInLast Then .SubItems(5) = Format$(rList.ListItems.count, "00000")
            .Key = rNodex.Key
            .Tag = rNodex.Key
        End With
    End If
    zItemDataSet = True
Exit Function
errop:
    Exit Function
End Function
'
Private Sub Class_Initialize()
'Debug.Print "ClsListViewOp--Class_Initialize" 'OK/2004/07/15
End Sub
Private Sub Class_Terminate()
'Debug.Print "ClsListViewOp--Class_Terminate" 'OK/2004/07/15
End Sub
'

