VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ClsListBox1ColumnDD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'ClsListBox1ColumnDD
Private Type ListBoxData
    ID          As Long     'User ListBox ID
    lt          As ListBox
    MaxCount    As Long     'LisCount Max          max 5000
    MaxListLen  As Long     'List String Max Len   max 2000
    IniHed      As String   '"" = no open save to ini file
    OnlySelf    As Boolean  'True = only Self DRagDrop OK
End Type
Private mUsers() As ListBoxData
'**************************************************************************************************
Friend Function UserAdd(rID As Long, lt As ListBox, rMaxCount As Long, rMaxListLen As Long, rIniHed As String, rOnlySelf As Boolean)
    Dim a As Long
    a = UBound(mUsers) + 1
    ReDim Preserve mUsers(a)
    With mUsers(a)
        .ID = rID
        Set .lt = lt
        .MaxCount = MinMax(1, 5000, (rMaxCount))
        .MaxListLen = MinMax(1, 2000, (rMaxListLen))
        .IniHed = rIniHed
        .OnlySelf = rOnlySelf
    End With
End Function
'**************************************************************************************************
Friend Sub UserDel(rID As Long)
    Dim a As Long, m As Long, Index As Long
    Index = UserIndex(rID)
    If Index > 0 Then
        m = UBound(mUsers) - 1
        For a = Index To m
            mUsers(a) = mUsers(a + 1)
        Next
        ReDim Preserve mUsers(m)
    End If
End Sub
'**************************************************************************************************
Friend Sub OLEStartDrag(lt As ListBox, AllowedEffects As Long)
    gDragModeFlag = UserID(lt)
    AllowedEffects = vbDropEffectCopy
End Sub
Friend Function OLEDragOver(lt As ListBox, Data As DataObject, Effect As Long, X As Single, Y As Single, State As Integer) As Boolean
On Error GoTo errop
    Dim e As Boolean, ID As Long
    ID = UserID(lt)
    e = (Data.GetFormat(vbCFText))
    If e Then e = (Trim$(Data.GetData(vbCFText)) <> "")
    e = e And (((Not OnlySelfDrag(ID)) And (lt.ListCount < ListMaxCount(ID))) Or (IsSelfDrag(ID)))
    Effect = IIf(e, vbDropEffectCopy, vbDropEffectNone)
    
'    Show line box

    OLEDragOver = e
Exit Function
errop:
    Exit Function
End Function
Friend Function OLEDragDrop(lt As ListBox, Data As DataObject, Effect As Long, X As Single, Y As Single) As Boolean
On Error GoTo errop
    Dim self As Boolean, a As Long, ID As Long, DoAdd As Boolean, s As String
    OLEDragDrop = False
    Effect = vbDropEffectCopy
    If (Data.GetFormat(vbCFText)) Then
        a = ListIndexFromXYSingleColumn(lt, X, Y)
        If a >= 0 Then
            ID = UserID(lt)
            self = IsSelfDrag(ID)
            If (Not self) Or (self And (a <> lt.ListIndex)) Then
                If OnlySelfDrag(ID) And (Not self) Then DoAdd = False Else DoAdd = True
                If self Then
                    If a > lt.ListIndex Then a = a - 1
                    If (a = lt.ListIndex) Or (a < 0) Then DoAdd = False
                End If
                If DoAdd Then
                    s = Left$(Data.GetData(vbCFText), ListMaxListLen(ID))
                    If Trim$(s) <> "" Then OLEDragDrop = AddDelUpDownList(0, lt, s, a, self)
                End If
            End If
        End If
    End If
    gDragModeFlag = 0
Exit Function
errop:
    Exit Function
End Function
Friend Sub OLECompleteDrag()
    gDragModeFlag = 0
End Sub
Friend Sub MouseUp()
    gDragModeFlag = 0
End Sub
'**************************************************************************************************
Friend Function AddDelUpDownList(op As Integer, lt As ListBox, AddStr As String, AddIndex As Long, SelfDrop As Boolean) As Boolean
'op    0=add,   1=del,   2=moveup,   3=movedown
On Error GoTo errop
    Dim n As Long, ID As Long
    AddDelUpDownList = False
    ID = UserID(lt)
    Select Case op
    Case 0  'add
        If AddStr = "" Then
            Beep
        ElseIf (lt.ListCount >= ListMaxCount(ID) + IIf(SelfDrop, 1, 0)) Then
            MsgBox "XgACe " + Format$(ListMaxCount(ID)) + " ɂȂĂ܂B" + CR2 + "ꂩ̃ACe폜ĂǉĂB", 64, "XgACeǉ"
        Else
            If SelfDrop Then lt.RemoveItem lt.ListIndex
            n = MinMax(0, (lt.ListCount), (AddIndex))
            lt.AddItem Left$(AddStr, ListMaxListLen(ID)), n
            lt.ListIndex = n
            AddDelUpDownList = True
        End If
    Case 1  'del
        n = lt.ListIndex
        If (n >= 0) Then lt.RemoveItem n
        lt.ListIndex = MinVal((n), lt.ListCount - 1)
        AddDelUpDownList = True
    Case 2, 3 'up 'down
        Call ListBoxItemUpDown(IIf(op = 2, "up", "dn"), lt)
        AddDelUpDownList = True
    End Select
Exit Function
errop:
    MsgBox Error$:  Exit Function
End Function
'**************************************************************************************************
Friend Sub AddDelUpDownBtnEnabled(lt As ListBox, eUserDef As Boolean, Btn0 As CommandButton, Btn1 As CommandButton, Btn2 As CommandButton, Btn3 As CommandButton)
'Btn As CommandButton    0=add,   1=del,   2=moveup,   3=movedown
On Error GoTo errop
    With lt
        If Not Btn0 Is Nothing Then Btn0.Enabled = eUserDef And (.ListCount < ListMaxCountByObj(lt))
        If Not Btn1 Is Nothing Then Btn1.Enabled = eUserDef And (.ListIndex >= 0)
        If Not Btn2 Is Nothing Then Btn2.Enabled = eUserDef And (.ListIndex > 0) And (.ListIndex < .ListCount)
        If Not Btn3 Is Nothing Then Btn3.Enabled = eUserDef And (.ListIndex >= 0) And (.ListIndex < .ListCount - 1)
    End With
Exit Sub
errop:
    Exit Sub
End Sub
'**************************************************************************************************
Friend Sub IniFileOpenSave(op As String, str() As String, CurIndex As Long)
On Error GoTo errop
    Dim a As Long, b As Long, w As String, ary() As String, cut As String, m As Long
    cut = Chr28
    m = UBound(mUsers)
    Select Case op
    Case "open"
        ReDim ary(m)
        For b = 1 To m
            ary(b) = mUsers(b).IniHed
        Next
        If StrAryAllNull(ary()) Then Exit Sub
        For a = 1 To UBound(str)
            w = str(a)
            For b = 1 To m
                If ary(b) <> "" Then
                    If InStr(w, ary(b)) = 1 Then
                        Call IniOpenSaveListItem("open", mUsers(b).lt, mUsers(b).MaxCount, mUsers(b).IniHed, cut, str(), a)
                        ary(b) = ""
                        If StrAryAllNull(ary()) Then Exit Sub
                        Exit For
                    End If
                End If
            Next
        Next
    Case "save"
        For b = 1 To m
            If mUsers(b).IniHed <> "" Then Call IniOpenSaveListItem("save", mUsers(b).lt, mUsers(b).MaxCount, mUsers(b).IniHed, cut, str(), CurIndex)
        Next
    End Select
Exit Sub
errop:
    Exit Sub
End Sub
'**************************************************************************************************
Friend Function IsCountAddEnable(lt As ListBox) As Boolean
    IsCountAddEnable = (lt.ListCount < ListMaxCountByObj(lt))
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Private Function OnlySelfDrag(rID As Long) As Boolean
    Dim a As Long
    a = UserIndex(rID)
    If a > 0 Then OnlySelfDrag = mUsers(a).OnlySelf Else OnlySelfDrag = False
End Function
'**************************************************************************************************
Private Function ListMaxCountByObj(lt As ListBox) As Long
    ListMaxCountByObj = ListMaxCount(UserID(lt))
End Function
'**************************************************************************************************
Private Function UserID(lt As ListBox) As Long
    Dim a As Long
    If Not lt Is Nothing Then
        For a = 1 To UBound(mUsers)
            If mUsers(a).lt Is lt Then
                UserID = mUsers(a).ID: Exit Function
            End If
        Next
    End If
    UserID = 0
End Function
'**************************************************************************************************
Private Function ListMaxCount(rID As Long) As Long
    Dim a As Long
    a = UserIndex(rID)
    If a > 0 Then ListMaxCount = mUsers(a).MaxCount Else ListMaxCount = 0
End Function
'**************************************************************************************************
Private Function ListMaxListLen(rID As Long) As Long
    Dim a As Long
    a = UserIndex(rID)
    If a > 0 Then ListMaxListLen = mUsers(a).MaxListLen Else ListMaxListLen = 250
End Function
'**************************************************************************************************
Private Function IsSelfDrag(rID As Long) As Boolean
    IsSelfDrag = (gDragModeFlag = rID)
End Function
'**************************************************************************************************
Private Function UserIndex(rID As Long) As Long
    Dim a As Long
    For a = 1 To UBound(mUsers)
        If mUsers(a).ID = rID Then
            UserIndex = a: Exit Function
        End If
    Next
    UserIndex = 0
End Function
'**************************************************************************************************
Private Sub Class_Initialize()
    ReDim mUsers(0)
    gDragModeFlag = 0
End Sub
