VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ClsListViewOp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'**************************************************************************************************
'**************************************************************************************************
Friend Sub ListItemDelIfNodeNothing(rList As ListView, rTreeNodes As Nodes)
    Dim a As Long
    With rList.ListItems
        For a = .count To 1 Step -1
            If FindNodeFromKey(rTreeNodes, .item(a).key) Is Nothing Then .Remove a
        Next
    End With
End Sub
'**************************************************************************************************
Friend Function ListItemGetFromNodeFullPath(rList As ListView, rFullPath As String) As ListItem
    Dim mItem As ListItem, a As Long
    Set ListItemGetFromNodeFullPath = Nothing
    For a = 1 To rList.ListItems.count
        Set mItem = rList.ListItems(a)
        If mItem.SubItems(1) = rFullPath Then
            Set ListItemGetFromNodeFullPath = mItem
            Exit Function
        End If
    Next
End Function
'**************************************************************************************************
Friend Function ListItemSelectFromNodeFullPath(rList As ListView, rFullPath As String) As ListItem
    Dim mItem As ListItem, a As Long
    Set ListItemSelectFromNodeFullPath = Nothing
    For a = 1 To rList.ListItems.count
        Set mItem = rList.ListItems(a)
        If mItem.SubItems(1) = rFullPath Then
            Set rList.SelectedItem = mItem
            mItem.EnsureVisible
            Set ListItemSelectFromNodeFullPath = mItem
            Exit Function
        End If
    Next
End Function
'**************************************************************************************************
Friend Function NodeGetFromListViewSelectedItem(rList As ListView, rTreeNodes As Nodes, Optional SelectIfNotFind As Boolean = False) As Node
    Dim mItem As ListItem
    Set mItem = ListViewSelectedItem(rList)
    If mItem Is Nothing Then
        If SelectIfNotFind And rList.ListItems.count > 0 Then
            Set rList.SelectedItem = rList.ListItems(1)
            rList.RefResh
            Set mItem = rList.SelectedItem
        End If
    End If
    Set NodeGetFromListViewSelectedItem = zFindNodeFromItem(rTreeNodes, mItem)
End Function
'**************************************************************************************************
Friend Function ListViewCurrentItemFullPath(rList As ListView) As String
    Dim mItem As ListItem
    Set mItem = ListViewSelectedItem(rList)
    If (Not mItem Is Nothing) Then ListViewCurrentItemFullPath = mItem.SubItems(1) Else ListViewCurrentItemFullPath = ""
End Function
'**************************************************************************************************
Friend Function ListViewCurrentItemKey(rList As ListView) As String
    Dim mItem As ListItem
    Set mItem = ListViewSelectedItem(rList)
    If (Not mItem Is Nothing) Then ListViewCurrentItemKey = mItem.key Else ListViewCurrentItemKey = ""
End Function
'**************************************************************************************************
Friend Function ListItemNodeSetNewTitlePath(rList As ListView, rNodex As Node) As Boolean
    Dim a As Long, mItem As ListItem
    ListItemNodeSetNewTitlePath = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = zFindItemFromNodeKey(rList, rNodex)
    If mItem Is Nothing Then Exit Function
    With mItem
        .Text = rNodex.Text
        .SubItems(1) = rNodex.FullPath
'        .SubItems(4) = rTagOp.TimeChange(rNodex.tag) '2002-0925@'^CgݒŕύXԂςׂ@?????????????
    End With
    ListItemNodeSetNewTitlePath = True
End Function
'**************************************************************************************************
Friend Function ListItemIconChange(rList As ListView, rNodex As Node) As Boolean
    Dim mItem As ListItem, mFindItem As ListItem, oldItem As ListItem, wTimeStr As String
    ListItemIconChange = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = zFindItemFromNodeKey(rList, rNodex)
    If mItem Is Nothing Then Exit Function
    mItem.SmallIcon = rNodex.Image
    ListItemIconChange = True
End Function
'**************************************************************************************************
Friend Function ListItemDataChange(rList As ListView, rNodex As Node, rTreeOp As ClsNodeDoc) As Boolean
    Dim mItem As ListItem
    ListItemDataChange = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = zFindItemFromNodeKey(rList, rNodex)
    If mItem Is Nothing Then Exit Function
    If False = zItemDataSet(mItem, rNodex, rTreeOp) Then Exit Function
    ListItemDataChange = True
End Function
'**************************************************************************************************
Friend Function ListItemAdd(rList As ListView, rNodex As Node, rTreeOp As ClsNodeDoc) As Boolean
    Dim mItem As ListItem, wTimeStr As String
    ListItemAdd = False
    If rNodex Is Nothing Then Exit Function
    Set mItem = rList.ListItems.add
    If False = zItemDataSet(mItem, rNodex, rTreeOp) Then
        rList.ListItems.Remove mItem.Index: Exit Function
    End If
    ListItemAdd = True
End Function
'**************************************************************************************************
Friend Sub LoadBookAllMemoItem(rList As ListView, rTreeNodes As Nodes, rBook As Node, rTreeOp As ClsNodeDoc)
    Dim a As Long, nodex As Node
    rList.ListItems.Clear
    For a = 1 To rTreeNodes.count
        Set nodex = TopNodeFromDescendantNode(rTreeNodes(a))
        If nodex Is rBook Then Call ListItemAdd(rList, rTreeNodes(a), rTreeOp)
    Next
End Sub
'**************************************************************************************************
Private Function zFindNodeFromItem(rTreeNodes As Nodes, rItem As ListItem) As Node
On Error GoTo errop
    Set zFindNodeFromItem = rTreeNodes(rItem.key)
Exit Function
errop:
    Set zFindNodeFromItem = Nothing: Exit Function
End Function
'**************************************************************************************************
Private Function zFindItemFromNodeKey(rList As ListView, rNodex As Node) As ListItem
On Error GoTo errop
    Set zFindItemFromNodeKey = rList.ListItems(rNodex.key)
Exit Function
errop:
    Set zFindItemFromNodeKey = Nothing: Exit Function
End Function
'**************************************************************************************************
Private Function zItemDataSet(mItem As ListItem, rNodex As Node, rTreeOp As ClsNodeDoc) As Boolean
On Error GoTo errop
    Dim ret As Long, wFileType As String, wFileSize As Long
    zItemDataSet = False
    Call rTreeOp.MemoFileTypeFileSize(rNodex, wFileType, wFileSize)
    With mItem
        .Text = rNodex.Text:
        .SmallIcon = rNodex.Image:
        .SubItems(1) = rNodex.FullPath:
        .SubItems(2) = wFileType:
        .SubItems(3) = Format$(FormatEx(wFileSize, 1), "@@@@@@@@@")
        .SubItems(4) = rTreeOp.TimeChange(rNodex.tag)
        .key = rNodex.key
    End With
    zItemDataSet = True
Exit Function
errop:
    Exit Function
End Function
