Attribute VB_Name = "LibFormControl"
Option Explicit
'**************************************************************************************************
Sub FormZoom(f As Form, zoomPerForm As Single, minPerScreen As Single, maxPerScreen As Single)
On Error GoTo errop
    Dim SWD As Single, SHT As Single, FWD As Single, FHT As Single
    SWD = Screen.Width
    SHT = Screen.Height
    FWD = MinMax(SWD * minPerScreen, SWD * maxPerScreen, f.Width * (1 + zoomPerForm))
    FHT = MinMax(SHT * minPerScreen, SHT * maxPerScreen, f.Height * (1 + zoomPerForm))
    If f.Width = FWD And f.Height = FHT Then Exit Sub
    f.Width = FWD
    f.Height = FHT
    Call FormMoveInScreen(f)
Exit Sub
errop:
    Exit Sub
End Sub
'**************************************************************************************************
Function Find95SysTaskBar_hWnd() As Long
    Find95SysTaskBar_hWnd = FindWindow("Shell_TrayWnd", "")
End Function
'**************************************************************************************************
Sub GetScreenRectWithOut95SysTaskBar(rc As RECT, Optional DoTwipsSize As Boolean = False)
    Dim hwnd As Long, scrn As RECT, r As RECT, tmp As RECT
    Call SetRect(scrn, 0, 0, (Screen.Width / gPxlX), (Screen.Height / gPxlY))
    hwnd = Find95SysTaskBar_hWnd()
    If (hwnd) <> 0 Then
        If (GetWindowRect(hwnd, r)) <> 0 Then
            If (SubtractRect(tmp, scrn, r)) <> 0 Then Call CopyRect(scrn, tmp)
        End If
    End If
    Call CopyRect(rc, scrn)
    If DoTwipsSize Then Call RectTwipPxlExChange("pxl_to_twp", rc, rc)
End Sub
'**************************************************************************************************
Sub FormPostSetCurCusorPoint(f As Form, Optional rLeftTop As Boolean = False)
    'tH[̈ʒu}EXʒuSɃZbg
    If f Is Nothing Then Exit Sub
    If f.MDIChild = True Or f.WindowState <> vbNormal Then Exit Sub
    Dim x As Single, y As Single, p As POINTAPI, rc As RECT, rc1 As RECT
    Call GetScreenRectWithOut95SysTaskBar(rc)
    Call RectTwipPxlExChange("pxl_to_twp", rc1, rc)
    If GetCursorPos(p) Then
        x = p.x * gPxlX
        y = p.y * gPxlY
        If rLeftTop = False Then 'default option = center
            x = x - (f.Width / 2)
            y = y - (f.Height / 2)
        End If
        x = MinMax((rc1.left), rc1.Right - f.Width, x)
        y = MinMax((rc1.top), rc1.Bottom - f.Height, y)
        f.Move x, y
    End If
End Sub
'**************************************************************************************************
Sub FormMoveInScreen(f As Form)
    'tH[̈ʒu Screen ɃZbg
    If f Is Nothing Then Exit Sub
    If f.MDIChild = True Or f.WindowState <> vbNormal Then Exit Sub
    Dim x1 As Single, x2 As Single, y1 As Single, y2 As Single, rc As RECT, r As RECT
    Call GetScreenRectWithOut95SysTaskBar(rc)
    Call RectTwipPxlExChange("pxl_to_twp", r, rc)
    With f
        If .Width >= RectWidth(r) Then Exit Sub
        If .Height >= RectHeight(r) Then Exit Sub
        x1 = .left
        x2 = .left + .Width
        y1 = .top
        y2 = .top + .Height
        If x1 < r.left Or x2 > r.Right Or y1 < r.top Or y2 > r.Bottom Then
            x1 = MinMax((r.left), (r.Right - .Width), .left)
            y1 = MinMax((r.top), (r.Bottom - .Height), .top)
            f.Move x1, y1
        End If
    End With
End Sub
'**************************************************************************************************
'Sub FormMoveScreenCenter(f As Form)
'    'tH[̈ʒu Screen SɃZbg
'    If f Is Nothing Then Exit Sub
'    If f.MDIChild = True Or f.WindowState <> vbNormal Then Exit Sub
'    Dim x As Single, y As Single, rc As RECT, rc1 As RECT, w As Single, h As Single
'    Call GetScreenRectWithOut95SysTaskBar(rc)
'    Call RectTwipPxlExChange("pxl_to_twp", rc1, rc)
'    w = RectWidth(rc1)
'    h = RectHeight(rc1)
'    x = rc1.Left + (w - f.Width) / 2
'    y = rc1.Top + (h - f.Height) / 2
'    x = MinMax((rc1.Left), rc1.Right - f.Width, x)
'    y = MinMax((rc1.Top), rc1.Bottom - f.Height, y)
'    f.Move x, y
'End Sub
'**************************************************************************************************
Function FormMoveOldPostWindowState(rForm As Form, rWindowState As Long, rOldLeft As Long, rOldTop As Long, _
                    Optional rOldWidth As Long = 0, Optional rOldHeight As Long = 0, _
                    Optional rMinmamWidth As Long = 3000, Optional rMinmamHeight As Long = 2000) As Boolean
    'TCY Twips Scale   2000/1/2
    On Error GoTo errop
    Dim x As Single, y As Single, w As Single, h As Single, rc As RECT, sw As Long, sh As Long, ErrSize As Boolean
    FormMoveOldPostWindowState = False
    If rForm.WindowState = vbNormal And rForm.MDIChild = False Then
        ErrSize = (rOldWidth < 1 Or rOldHeight < 1 Or (rWindowState <> vbNormal))
        Call GetScreenRectWithOut95SysTaskBar(rc, True)
        sw = RectWidth(rc)
        sh = RectHeight(rc)
        If ErrSize Then
            w = MinVal(rForm.Width, sw - 500)
            h = MinVal(rForm.Height, sh - 500)
            x = rc.left + (sw - w) / 2
            y = rc.top + (sh - h) / 2
        Else
            w = MinMax((rMinmamWidth), sw - 500, (rOldWidth))
            h = MinMax((rMinmamHeight), sh - 500, (rOldHeight))
            x = MinMax((rc.left), rc.Right - w, (rOldLeft))
            y = MinMax((rc.top), rc.Bottom - h, (rOldTop))
        End If
        If rForm.BorderStyle = vbSizable Or rForm.BorderStyle = vbSizableToolWindow Then
            rForm.Move x, y, w, h
        Else
            rForm.Move x, y
        End If
        x = rForm.BorderStyle
        If x = vbFixedSingle Or x = vbSizable Then
            rForm.WindowState = IIf(rWindowState = vbMaximized, vbMaximized, vbNormal)
        End If
        FormMoveOldPostWindowState = True
    End If
Exit Function
errop:
    Exit Function
End Function
'**************************************************************************************************
Function FormDlgLoadUnloadOpReadWrite(op As Long, rwData() As gtype_FormLoadUnloadOpData, Str() As String, CurIndex As Long, Optional FormsNames As String) As Boolean
    '2000-01-15
    Const KeyFormsWndDatas = "FormsWndDatas="
    Const KeyEnd = "[EndFormsWndDatas]"
    Dim a As Long, cut As String, max As Long, n As Long, w As String, ary() As String
    FormDlgLoadUnloadOpReadWrite = False
    cut = Chr20
    Select Case op
    Case opREAD
        For a = 1 To UBound(rwData): rwData(a).Showing = False: Next
        a = 0
        For n = 1 To UBound(Str)
            w = Str(n)
            If InStr(w, KeyFormsWndDatas) = 1 Then
                w = Right$(w, Len(w) - Len(KeyFormsWndDatas))
                max = StrCut(w, cut, ary())
                If max = 7 Then
                    '݂̃o[WŎgpĂ邩mF^ߋ̃o[W̌Â Form f[^[폜
                    If InStr(FormsNames, "-" + ary(1)) > 0 Then
                        a = a + 1
                        If a > UBound(rwData) Then Exit For
                        rwData(a).FormName = ary(1)
                        rwData(a).WindowState = Val(ary(2))
                        rwData(a).left = Val(ary(3))
                        rwData(a).top = Val(ary(4))
                        rwData(a).Width = Val(ary(5))
                        rwData(a).Height = Val(ary(6))
                        rwData(a).DataStr = ary(7)
'                        Debug.Print "UsingForm = " + ary(1)
                    Else
'                        Debug.Print "DeleteOldForm = " + ary(1)
                    End If
                End If
            ElseIf InStr(w, KeyEnd) = 1 Then
                Exit For
            End If
        Next
    Case opSAVE
        max = UBound(Str)
        Call AryReDimAddStrAddIndex(Str(), CurIndex, max, "")
        For a = 1 To UBound(rwData)
            If rwData(a).FormName <> "" Then
                Call AryReDimAddStrAddIndex(Str(), CurIndex, max, KeyFormsWndDatas + _
                    rwData(a).FormName + cut + _
                    Format$(rwData(a).WindowState) + cut + _
                    Format$(rwData(a).left) + cut + _
                    Format$(rwData(a).top) + cut + _
                    Format$(rwData(a).Width) + cut + _
                    Format$(rwData(a).Height) + cut + _
                    rwData(a).DataStr + cut)
            End If
        Next
        Call AryReDimAddStrAddIndex(Str(), CurIndex, max, KeyEnd)
    End Select
    FormDlgLoadUnloadOpReadWrite = True
End Function
'**************************************************************************************************
Function FormDlgLoadUnloadOp(op As String, rwData() As gtype_FormLoadUnloadOpData, Optional rForm As Form = Nothing, Optional rwStr As String = "") As Boolean
    'EChËʒuݒ肳Ȃꍇɂ
    'rwStr  FORM_LOAD_UNLOAD_OP_MOVE_CANSEL ܂܂ČĂяoB
    'Instr(rwStr, FORM_LOAD_UNLOAD_OP_MOVE_CANSEL) > 0
    '2000-01-15
    Dim a As Long, p As Long, s As String, w As String, MoveCancel As Boolean, FormTag As String
    Dim OldLeft As Long, OldTop As Long, OldWidth As Long, oldHeight As Long, WndState As Long
    FormDlgLoadUnloadOp = False
    Select Case op
    Case "DataStr" 'rwStr = input FormName / return rwData(a).DataStr
        Call FormDlgLoadUnloadOp("FormDataIndex", rwData(), rForm, rwStr)
        a = Val(rwStr)
        If a > 0 Then rwStr = rwData(a).DataStr Else rwStr = ""
    
    Case "FormDataIndex" 'rwStr = input FormName / return index
        For a = 1 To UBound(rwData)
            If rwData(a).FormName = rwStr Then Exit For
        Next
        If a > UBound(rwData) Then a = 0
        rwStr = Format$(a)
    
    Case "load", "loadcom"
        MoveCancel = (InStr(rwStr, FORM_LOAD_UNLOAD_OP_MOVE_CANSEL) > 0)
        s = rForm.Name
        For a = 1 To UBound(rwData)
            If rwData(a).FormName = s Then Exit For
        Next
        If a > UBound(rwData) Then
            WndState = 0
            OldLeft = 0
            OldTop = 0
            OldWidth = 0
            oldHeight = 0
            For a = 1 To UBound(rwData)
                If rwData(a).FormName = "" Then Exit For
            Next
        Else
            WndState = rwData(a).WindowState
            OldLeft = rwData(a).left
            OldTop = rwData(a).top
            OldWidth = rwData(a).Width
            oldHeight = rwData(a).Height
            rwStr = rwData(a).DataStr
        End If
        If a > UBound(rwData) Then
            MsgBox "error in ""FormDlgLoadUnloadOp"" ary() size over !":  Exit Function
        End If
        '-------------------------------------
        If op = "loadcom" Then
            GoSub MakechkTag
            p = InStr(rwStr, FormTag)
            If p > 0 And p + 35 - 1 <= Len(rwStr) Then
                WndState = MinMax(0, 3, Val(Mid$(rwStr, p + 10, 5)))
                OldLeft = Val(Mid$(rwStr, p + 15, 5))
                OldTop = Val(Mid$(rwStr, p + 20, 5))
                OldWidth = Val(Mid$(rwStr, p + 25, 5))
                oldHeight = Val(Mid$(rwStr, p + 30, 5))
            End If
        End If
        '-------------------------------------
        If Not MoveCancel Then
            If False = FormMoveOldPostWindowState(rForm, WndState, OldLeft, OldTop, OldWidth, oldHeight) Then Exit Function
        End If
        '-------------------------------------
        rwData(a).FormName = s
        rwData(a).Showing = True
        If rForm.WindowState <> vbMinimized Then
            rwData(a).WindowState = rForm.WindowState
            rwData(a).left = rForm.left
            rwData(a).top = rForm.top
            rwData(a).Width = rForm.Width
            rwData(a).Height = rForm.Height
        End If
        '-------------------------------------
        If op = "loadcom" Then GoSub DataStrMakeRep
        '-------------------------------------
        rwData(a).DataStr = rwStr
        FormDlgLoadUnloadOp = True
        
    Case "unload", "unload_no_widthheight", "onsize", "unloadcom"
        With rForm
            s = .Name
            For a = 1 To UBound(rwData)
                If rwData(a).FormName = s Then
                    '-------------------------------------
                    If op = "unloadcom" Then
                        If rwStr = "" Then
                            rwStr = rwData(a).DataStr
                        Else
                            p = InStr(rwData(a).DataStr, Chr21)
                            If p > 0 Then rwStr = rwStr + Mid$(rwData(a).DataStr, p)
                        End If
                        GoSub DataStrMakeRep
                    End If
                    '-------------------------------------
                    If .WindowState <> vbMinimized Then
                        rwData(a).WindowState = .WindowState
                        rwData(a).left = .left
                        rwData(a).top = .top
                        If op <> "unload_no_widthheight" Then
                            rwData(a).Width = .Width
                            rwData(a).Height = .Height
                        End If
                    End If
                    If op <> "onsize" Then
                        rwData(a).Showing = False
                        rwData(a).DataStr = rwStr
                    End If
                    FormDlgLoadUnloadOp = True
                    Exit For
                End If
            Next
        End With
        
    Case "IsAnyFormLoadedCheck"
        For a = 1 To UBound(rwData)
            If rwData(a).Showing And (Not (rwData(a).FormName = rwStr)) Then  'rwStr = "frmMain"
                FormDlgLoadUnloadOp = True:    Exit Function
            End If
        Next
        
    Case Else
        'op = rForm.Name  !!! when check form is showing
        For a = 1 To UBound(rwData)
            If op = rwData(a).FormName Then
                FormDlgLoadUnloadOp = rwData(a).Showing:    Exit Function
            End If
        Next
        
    End Select
    
Exit Function
MakechkTag:  'tag from user = "01" -- to -- "99"
    FormTag = "#$%&@[<?" + Format$(Val(rForm.tag), "00")
    Return
    
DataStrMakeRep:
    GoSub MakechkTag
    w = FormTag     'Form.tag = "#$%&@[<?00"        '10
    w = w + Format$(rForm.WindowState, "00000")     '15
    w = w + Format$(rForm.left, "00000")            '20
    w = w + Format$(rForm.top, "00000")             '25
    w = w + Format$(rForm.Width, "00000")           '30
    w = w + Format$(rForm.Height, "00000")          '35
    p = InStr(rwStr, FormTag)
    If p > 0 Then
        Mid$(rwStr, p) = w
    Else
        rwStr = rwStr + Chr21 + w
    End If
    Return
    
End Function
''**************************************************************************************************
'Sub FormReSizeEvent_FormSizeSet(f As Form, c As Control, Rspace As Single, Bspace As Single)
''Rspace / Bspace Rg[ c ̗̍]w肷BtH[XP[[hɈˑlB
'On Error GoTo errop
'    Dim oldScalemode As Long, X As Single, Y As Single
'    If Not f.Moveable Then Exit Sub
'    If f.WindowState <> vbNormal Then Exit Sub
'    With f
'        Select Case .ScaleMode
'        Case vbTwips
'            X = Rspace
'            Y = Bspace
'        Case vbPixels
'            X = Rspace * gPxlX
'            Y = Bspace * gPxlY
'        Case Else
'            Exit Sub
'        End Select
'        '----------------------------------
'        oldScalemode = .ScaleMode
'        .ScaleMode = vbTwips
'        '----------------------------------
'        X = (.Width - .ScaleWidth) + ControlRight(c) + X
'        Y = (.Height - .ScaleHeight) + ControlBottom(c) + Y
'        '----------------------------------
'        .ScaleMode = oldScalemode
'        '----------------------------------
'        If X <= Screen.Width And Y <= Screen.Height Then
'            .Move .left, .top, X, Y
'        End If
'    End With
'Exit Sub
'errop:
'    MsgBox Error$: Exit Sub
'End Sub
'**************************************************************************************************
Function Form_Resize_MoveControl(ParentForm As Form, ChildControl As Control, _
                LeftSpace As Long, TopSpace As Long, RightSpace As Long, BottomSpace As Long, _
                MinmamWidth As Long, MinmamHeight As Long) As Boolean
'1999-10-18 tH[(ParentForm) ɂ킹 Rg[(ChildControl) TCYύX
    Form_Resize_MoveControl = False
    On Error GoTo err_Form_Resize_MoveControl
    Dim w As Single, h As Single
    If ParentForm.WindowState <> vbMinimized Then
        w = MinMax((MinmamWidth), Screen.Width, (ParentForm.ScaleWidth - LeftSpace - RightSpace))
        h = MinMax((MinmamHeight), Screen.Height, (ParentForm.ScaleHeight - TopSpace - BottomSpace))
        ChildControl.Move LeftSpace, TopSpace, w, h
    End If
    Form_Resize_MoveControl = True
Exit Function
err_Form_Resize_MoveControl:
    Exit Function
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'Public Function FormAdjustHeightByTextBox(f As Form, tx As TextBox, ScrollBarAdd As Boolean, AddHeight As Single) As Single
'    'Form Height Set By TextBox LineCount
'    Const EM_GETLINECOUNT = &HBA
'    FormAdjustHeightByTextBox = 4000
'    Dim a As Long
'    If tx.text <> "" Then
'        a = CInt(SendMessage(tx.hwnd, EM_GETLINECOUNT, 0, 0)) 'EM_GETLINECOUNT
'        If a >= 0 Then
'            FormAdjustHeightByTextBox = MinVal((GetWindowSizeAddHeight(f, ScrollBarAdd) + AddHeight + (a * f.TextHeight("A"))), (Screen.Height - 500))
'        End If
'    End If
'End Function
'**************************************************************************************************
'Function GetClientWndOnParent(c As Control, InRect As RECT, scalex As Long, scaley As Long) As Boolean
'    '97-11-11 Rg[ e Window Wł  ClientRect RECT 擾
'    'scalex / scaley ̓XP[[hɂ{
'    'G[Ȃ  InRect.let / top /right, bottom = 0 Ԃ
'    GetClientWndOnParent = False
'    Dim rc As RECT
'    Dim pt As POINTAPI
'    Dim X As Long
'    Dim Y As Long
'    On Error GoTo errop
'    Call SetRectEmpty(InRect)
'    If GetWindowRect(c.hwnd, rc) And GetClientRect(c.hwnd, InRect) Then
'        pt.X = InRect.Left
'        pt.Y = InRect.Top
'        If ClientToScreen(c.hwnd, pt) Then
'            X = pt.X - rc.Left
'            Y = pt.Y - rc.Top
'            If OffsetRect(InRect, X, Y) Then
'                InRect.Left = InRect.Left * scalex
'                InRect.right = InRect.right * scalex
'                InRect.Top = InRect.Top * scaley
'                InRect.bottom = InRect.bottom * scaley
'                If OffsetRect(InRect, (c.Left), (c.Top)) Then
'                    GetClientWndOnParent = True
'                    Exit Function
'                End If
'            End If
'        End If
'    End If
'Exit Function
'errop:
'    Exit Function
'End Function
'**************************************************************************************************
'Public Function GetWindowRectOnParent(hwnd As Long, rc As RECT) As Boolean
'    Dim p As POINTAPI, parenthwnd As Long, w As Long, h As Long
'    GetWindowRectOnParent = False
'    If hwnd = 0 Then Exit Function
'    If GetWindowRect(hwnd, rc) Then
'        parenthwnd = GetParent(hwnd)
'        If parenthwnd Then
'            w = RectWidth(rc)
'            h = RectHeight(rc)
'            p.X = rc.Left: p.Y = rc.Top
'            If ScreenToClient(parenthwnd, p) Then Call SetRect(rc, p.X, p.Y, p.X + w, p.Y + h)
'        End If
'        GetWindowRectOnParent = True
'    End If
'End Function
'**************************************************************************************************
'Function GetWindowSizeAddHeight(f As Form, ScrollBarAdd As Boolean) As Single
'    'FormHeight - ClientHeight
'    Const SM_CYHSCROLL = 3
'    GetWindowSizeAddHeight = 2000
'    Dim r1 As RECT, r2 As RECT, n1 As Long, n2 As Long, Y1 As Long, h As Long
'    n1 = GetWindowRect(f.hwnd, r1)    'Long
'    n2 = GetClientRect(f.hwnd, r2)    'Long
'    Y1 = GetSystemMetrics(SM_CYHSCROLL)
'    If n1 <> 0 And n2 <> 0 And Y1 <> 0 Then
'        h = r1.bottom - r1.Top - r2.bottom
'        If ScrollBarAdd Then h = h + Y1
'        GetWindowSizeAddHeight = h * gPxlY:
'    End If
'End Function
'**************************************************************************************************
'Sub GetWindowSizeAddWidthHeight(hwnd As Long, addWD As Long, addHT As Long, twip As Boolean)
'    'border width * 2
'    Dim r1 As RECT, r2 As RECT, n1 As Long, n2 As Long, bai As Long
'    n1 = GetWindowRect(hwnd, r1)    'Long
'    n2 = GetClientRect(hwnd, r2)    'Long
'    If n1 <> 0 And n2 <> 0 Then
'        addWD = r1.right - r1.Left - r2.right
'        addHT = r1.bottom - r1.Top - r2.bottom
'        If twip Then
'            addWD = addWD * gPxlX:
'            addHT = addHT * gPxlY:
'        End If
'    End If
'End Sub
'**************************************************************************************************
'Sub SetWindowPostTopOrNext(wnd As Long, toppost As Boolean)
'    'EChEgbvEChEɐݒ(true)^(false)
'    Const HWND_NOTOPMOST = -2
'    Const HWND_TOPMOST = -1
'    Const SWP_NOACTIVATE = &H10
'    Const SWP_NOMOVE = &H2
'    Const SWP_NOSIZE = &H1
'    If wnd = 0 Then Exit Sub
'    Dim op As Long
'    Dim State As Long
'    If (toppost) Then op = HWND_TOPMOST Else op = HWND_NOTOPMOST
'    State = SWP_NOMOVE + SWP_NOSIZE + SWP_NOACTIVATE
'    Call SetWindowPos(wnd, op, 0, 0, 0, 0, State)
'End Sub
'**************************************************************************************************
'Public Function SetTopWindow(hwnd As Long, bState As Boolean) As Boolean
'    If bState = True Then '޳ŏʂɔzu܂B
'        SetTopWindow = SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, HWND_TOPSET_FLAGS)
'    ElseIf bState = False Then ' ŏ׸ނ̂ɂ܂B
'        SetTopWindow = SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, HWND_TOPSET_FLAGS)
'    Else
'        SetTopWindow = False
'    End If
'End Function
'**************************************************************************************************
'Public Sub TabStopOffOnFormAllControls(rForm As Form, rOnOff As Boolean)
'    'TabStop vpeBȂRg[ɑ΂G[𖳎܂B
'    Dim c As Control
'    On Error Resume Next
'    'Tab L[Ƃ̃tH[JX̕ύX𖳌ɂ܂B
'    For Each c In rForm.Controls
'        c.TabStop = rOnOff
'    Next c
'End Sub
'**************************************************************************************************
'Public Sub AppFormsAllEnabledSet(rCurForm As Form, rOtherFormEnable As Boolean)
'    Dim frm As Form
'    For Each frm In Forms
'        If frm Is rCurForm Then
'            'no op
'        Else
'            frm.Enabled = rOtherFormEnable
'        End If
'    Next
'End Sub
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function SetRedraw(hwnd As Long, lState As Long) As Long
    ' XV𖳌ɂɂ iState = 0 ɐݒ肵܂B
    ' XVLɂɂ iState = 1 ɐݒ肵܂B
    Dim lRetVal As Long
    On Error GoTo SetRedraw_Error
    lRetVal = SendMessage(hwnd, WM_SETREDRAW, lState, 0)
    If lRetVal <> False Then GoTo SetRedraw_Error
    SetRedraw = True
    Exit Function
SetRedraw_Error:
    SetRedraw = lRetVal
    Exit Function
End Function
'**************************************************************************************************
Sub TextBoxOLEDragDropSelTextSet(tx As TextBox, Data As DataObject, Effect As Long, rSetEnabled As Boolean)
    Dim a As Long, w As String
    Effect = vbDropEffectCopy
    If (Data.GetFormat(vbCFText)) Then
        a = tx.MaxLength - LenB(tx.Text) + LenB(tx.SelText)
        a = a / 2
        w = left$(Data.GetData(vbCFText), a)
        If rSetEnabled Then tx.SelText = w Else Beep
    End If
End Sub
'**************************************************************************************************
Function DragFontOp(op As String, Data1 As DataObject, Data2 As RichTextLib.DataObject, Effect As Long, Optional lbl As Label = Nothing) As Boolean
On Error GoTo exitop
    Dim e As Boolean, c As Control, box As RichTextBox, FT As gTypeFontColor
    DragFontOp = False
    If op = "over" Then
        e = (gDragModeFlag = gDROP_FROM_RICHTEXT Or gDragModeFlag = gDROP_WNDS_FONT_SAMP Or gDragModeFlag = gDROP_WNDS_TEXT_SUB Or gDragModeFlag = gDROP_WNDS_TMPLATE)
        Effect = IIf(e, vbDropEffectCopy, vbDropEffectNone)
        DragFontOp = True
    Else 'drag drop
'        If Not Data1 Is Nothing Then
'            If Data1.GetFormat(vbCFText) Then
'                Debug.Print Data1.GetData(vbCFText)
'            End If
'        ElseIf Not Data2 Is Nothing Then
'            If Data2.GetFormat(vbCFText) Then
'                Debug.Print Data2.GetData(vbCFText)
'            End If
'        End If
        Effect = vbDropEffectCopy
        If Not lbl Is Nothing Then
            If gFONT.FontDragOpFontSmpwnd("Drop", False, "", 0, Data1, Data2, FT, lbl) Then
                DragFontOp = True
            Else
                With frmMain
                    Set c = .ActiveControl
                    If (c Is .txtEdit(0)) Or (c Is .txtEdit(1)) Or (c Is .txtEdit(2)) Or (c Is .txtSub) Or (c Is .richTmplate) Then
                        If TypeOf c Is RichTextBox Then
                            DragFontOp = gFONT.FontColorOpSTD("setFromCONT", lbl, c, gTmpFT, "", 0, 0, 0, 0, 0, 0, 0, False, True, True)
                        End If
                    End If
                End With
            End If
        End If
        GoTo exitop
    End If
Exit Function
exitop:
    gDragModeFlag = 0
    Exit Function
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'Function DragFontOpaaa(op As String, Data1 As DataObject, Data2 As RichTextLib.DataObject, Data3 As ComctlLib.DataObject) As Boolean
''
'End Function
'**************************************************************************************************
'Function DragFontOpbbb() As Boolean
'    Call DragFontOpaaa("", Nothing, Nothing, Nothing)
'End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
