Attribute VB_Name = "LibTreeView"
Option Explicit
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NodeFullPathCheckNothing(rNode As Node) As String
    If Not rNode Is Nothing Then NodeFullPathCheckNothing = rNode.FullPath Else NodeFullPathCheckNothing = ""
End Function
'**************************************************************************************************
Public Function NodeFullPathCheckIndex(rNodes As Nodes, rIndex As Long) As String
    If rIndex > 0 And rIndex <= rNodes.count Then NodeFullPathCheckIndex = rNodes(rIndex).FullPath Else NodeFullPathCheckIndex = ""
End Function
'**************************************************************************************************
Public Function NodeKeyCheckNothing(rNode As Node) As String
    If Not rNode Is Nothing Then NodeKeyCheckNothing = rNode.key Else NodeKeyCheckNothing = ""
End Function
'**************************************************************************************************
Public Function NodeTagCheckNothing(rNode As Node) As String
    If Not rNode Is Nothing Then NodeTagCheckNothing = rNode.tag Else NodeTagCheckNothing = ""
End Function
'**************************************************************************************************
Public Function NodeTextFromFullPath(rNodeFullPath As String, rSep As String) As String
    Dim a As Long
    NodeTextFromFullPath = ""
    If rNodeFullPath = "" Or rSep = "" Then Exit Function
    a = InstrBack(Len(rNodeFullPath), rNodeFullPath, rSep, "")
    If a > 0 Then NodeTextFromFullPath = Mid$(rNodeFullPath, a + 1) Else NodeTextFromFullPath = rNodeFullPath
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NodeChildCountNothingSafe(rNodex As Node) As Long
    If rNodex Is Nothing Then
        NodeChildCountNothingSafe = 0
    Else
        NodeChildCountNothingSafe = rNodex.Children
    End If
End Function
'**************************************************************************************************
Public Function NodeCountParentAndAllDescendant(rNodex As Node) As Long
    Dim wNodeAry() As Node
    NodeCountParentAndAllDescendant = 0
    ReDim wNodeAry(0)
    If NodeAryParentAndAllDescendant(rNodex, wNodeAry()) Then NodeCountParentAndAllDescendant = UBound(wNodeAry)
End Function
'**************************************************************************************************
Public Function NodeCountAllBrothersDescendant(rNodex As Node) As Long
    NodeCountAllBrothersDescendant = 0
    If rNodex Is Nothing Then Exit Function
    If rNodex.Parent Is Nothing Then Exit Function
    NodeCountAllBrothersDescendant = NodeCountParentAndAllDescendant(rNodex.Parent) - 1
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NodeTopsFirst(rNodes As Nodes) As Node
    'c[EChEŜ̍ŏ̃m[h
    Dim a As Long, wNodeAry() As Node
    Set NodeTopsFirst = Nothing
    If Not NodeAryAllTops(rNodes, wNodeAry()) Then Exit Function
    For a = 1 To UBound(wNodeAry())
        If wNodeAry(a).Previous Is Nothing Then
            Set NodeTopsFirst = wNodeAry(a): Exit Function
        End If
    Next
End Function
'**************************************************************************************************
Public Function FirstHedNode(rNodes As Nodes) As Node
    Dim nodex As Node
    Set FirstHedNode = Nothing
    If rNodes.count > 0 Then
        Set nodex = TopNodeFromDescendantNode(rNodes(1))
        If Not nodex Is Nothing Then Set nodex = nodex.FirstSibling
        Set FirstHedNode = nodex
    End If
End Function
'**************************************************************************************************
Public Function TopNodeFromDescendantNode(rNodex As Node) As Node
    'rNodex ̍ŏʂ̐ełgbvm[hT
    On Error GoTo errop
    Dim nodeTmp As Node, nodeRet As Node
    Set TopNodeFromDescendantNode = Nothing
    If rNodex Is Nothing Then Exit Function
    Set nodeTmp = rNodex
    Set nodeRet = rNodex
    Do While Not (nodeTmp Is Nothing)
        Set nodeRet = nodeTmp
        Set nodeTmp = nodeTmp.Parent  '************?????????????/
    Loop
    Set TopNodeFromDescendantNode = nodeRet
Exit Function
errop:
    Exit Function
End Function
'**************************************************************************************************
Public Function LastEndNode(rNodes As Nodes) As Node
    Dim nodex As Node
    Set LastEndNode = Nothing
    If rNodes.count > 0 Then
        Set nodex = TopNodeFromDescendantNode(rNodes(1))
        If Not nodex Is Nothing Then
            Set nodex = nodex.LastSibling
            Set LastEndNode = ChildLastEndNode(rNodes, nodex)
        End If
    End If
End Function
'**************************************************************************************************
Public Function ChildLastEndNode(rNodes As Nodes, rNode As Node) As Node
    Dim nodex As Node
    Set nodex = rNode.child
    If nodex Is Nothing Then
        Set ChildLastEndNode = rNode
    Else
        Set nodex = nodex.LastSibling
        Set ChildLastEndNode = ChildLastEndNode(rNodes, nodex)
    End If
End Function
'**************************************************************************************************
Public Function ParentsNodeNext(rNodes As Nodes, rNode As Node) As Node
    Dim nodex As Node
    If rNodes.count > 0 Then
        If Not rNode Is Nothing Then
            Set nodex = rNode.Parent
            Do While Not nodex Is Nothing
                If Not nodex.Next Is Nothing Then
                    Set ParentsNodeNext = nodex.Next
                    Exit Function
                End If
                Set nodex = nodex.Parent
            Loop
        End If
    End If
    Set ParentsNodeNext = Nothing
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function FindNodeFromKey(rNodes As Nodes, rKey As String) As Node
    On Error GoTo errop
    Set FindNodeFromKey = Nothing
    If rKey = "" Then Exit Function
    Set FindNodeFromKey = rNodes(rKey)
Exit Function
errop:
    Exit Function
End Function
'**************************************************************************************************
Public Function FindNodeFullPathFromKey(rNodes As Nodes, rKey As String) As String
    Dim nodex As Node
    Set nodex = FindNodeFromKey(rNodes, rKey)
    If nodex Is Nothing Then FindNodeFullPathFromKey = "" Else FindNodeFullPathFromKey = nodex.FullPath
End Function
'**************************************************************************************************
Public Function FindNodeFromIndex(rNodes As Nodes, rIndex As String) As Node
    On Error GoTo errop
    Set FindNodeFromIndex = Nothing
    If rIndex = 0 Then Exit Function
    Set FindNodeFromIndex = rNodes(rIndex)
Exit Function
errop:
    Exit Function
End Function
'**************************************************************************************************
Public Function FindNodeFromFullPath(rNodes As Nodes, rFullPath As String) As Node
    'rFullPath ɂ Node T
    Dim a As Long
    If Len(rFullPath) > 0 Then
        For a = 1 To rNodes.count
            If rNodes(a).FullPath = rFullPath Then
                Set FindNodeFromFullPath = rNodes(a): Exit Function
            End If
        Next
    End If
    Set FindNodeFromFullPath = Nothing
End Function
'**************************************************************************************************
Public Function FindNodeFromFullPathByBookNameAry(Books() As String, rSep As String, rNodes As Nodes, rFullPath As String) As Node
    'Books()  /  rFullPath ɂ Node T
    Dim a As Long, c As Long, Bo As String
    If Len(rFullPath) > 0 Then
        For c = 1 To UBound(Books)
            Bo = Books(c)
            If (rFullPath = Bo) Or (InStr(rFullPath, Bo + rSep) = 1) Then
                For a = 1 To rNodes.count
                    If rNodes(a).FullPath = rFullPath Then
                        Set FindNodeFromFullPathByBookNameAry = rNodes(a): Exit Function
                    End If
                Next
            End If
        Next
    End If
    Set FindNodeFromFullPathByBookNameAry = Nothing
End Function
'**************************************************************************************************
Public Function NodeSelectFromFullPath(rTrv As TreeView, rFullPath As String) As Node
    'rTrv 
    Dim nodex As Node
    Set nodex = FindNodeFromFullPath(rTrv.Nodes, rFullPath)
    If Not nodex Is Nothing Then Set rTrv.SelectedItem = nodex
    Set NodeSelectFromFullPath = nodex
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function IsTopNode(rNodex As Node) As Boolean
    'rNodex eȂgbvm[hł True Ԃ
    If rNodex Is Nothing Then
        IsTopNode = False
    Else
        IsTopNode = (rNodex.Parent Is Nothing)
    End If
End Function
'**************************************************************************************************
Public Function IsNodeParent(rNodeParent As Node, rNodex As Node) As Boolean
    'rNodeParent  rNodex ̐eł True Ԃ
    IsNodeParent = False
    If rNodeParent Is Nothing Then Exit Function
    If rNodex Is Nothing Then Exit Function
    IsNodeParent = (rNodeParent Is rNodex.Parent)
End Function
'**************************************************************************************************
Public Function IsNodeDescendant(rNodeParent As Node, rNodex As Node) As Boolean
    'rNodex  rNodeParent ̎qł True Ԃ
    Dim nodeTmp As Node
    IsNodeDescendant = False
    If rNodeParent Is Nothing Then Exit Function
    If rNodex Is Nothing Then Exit Function
    If Not (rNodeParent Is rNodex) Then
        Set nodeTmp = rNodex.Parent
        Do While Not (nodeTmp Is Nothing)
            If nodeTmp Is rNodeParent Then
                IsNodeDescendant = True:  Exit Function
            End If
            Set nodeTmp = nodeTmp.Parent
        Loop
    End If
End Function
'**************************************************************************************************
Public Function IsAnyNodeSelected(rTrv As TreeView) As Boolean
    'rTrv łꂩ̃m[hIĂ True Ԃ
    Dim nodex As Node
    Set nodex = rTrv.SelectedItem
    If nodex Is Nothing Then IsAnyNodeSelected = False Else IsAnyNodeSelected = True
End Function
'**************************************************************************************************
Public Function IsTopNodeSelected(rTrv As TreeView) As Boolean
    'rTrv Ńgbvm[hIĂ True Ԃ
    Dim nodex As Node, nodeparent As Node
    IsTopNodeSelected = False
    Set nodex = rTrv.SelectedItem
    If Not (nodex Is Nothing) Then
        Set nodeparent = nodex.Parent
        If (nodeparent Is Nothing) Then IsTopNodeSelected = True
    End If
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function IsNodeHas_Brother(rNodex As Node) As Boolean
    IsNodeHas_Brother = False
    If rNodex Is Nothing Then Exit Function
    IsNodeHas_Brother = (Not rNodex.Previous Is Nothing) Or (Not rNodex.Next Is Nothing)
End Function
'**************************************************************************************************
Public Function IsNodeHas_Child(rNodex As Node) As Boolean
    IsNodeHas_Child = False
    If rNodex Is Nothing Then Exit Function
    IsNodeHas_Child = (Not rNodex.child Is Nothing)
End Function
'**************************************************************************************************
Public Function IsNodeHas_Any_Descendant(rNodex As Node) As Boolean
    'n̍ŏ̎qł͂Ȃ̌Z̎q܂
    IsNodeHas_Any_Descendant = False
    Dim n As Node, m As Node
    If rNodex Is Nothing Then Exit Function
    Set n = rNodex.child
    If n Is Nothing Then Exit Function
    Set m = n.child
    Do While m Is Nothing
        Set n = n.Next
        If n Is Nothing Then Exit Function
        Set m = n.child
    Loop
    IsNodeHas_Any_Descendant = (Not m Is Nothing)
End Function
'**************************************************************************************************
Public Function IsNodeHas_Brother_Child_Descendant(rNodex As Node, wBrother As Boolean, wChild As Boolean, wDescendant As Boolean) As Boolean
    Dim nod As Node, wNodeAry() As Node, a As Long
    IsNodeHas_Brother_Child_Descendant = False
    wBrother = False
    wChild = False
    wDescendant = False
    If rNodex Is Nothing Then Exit Function
    wBrother = IsNodeHas_Brother(rNodex)
    wChild = IsNodeHas_Child(rNodex)
    If wChild Then
        ReDim wNodeAry(0)
        Call NodeAryParentAndAllChild(rNodex, wNodeAry()) 'eg wNodeAry() ̍ŏɂ͂Ă
        For a = 2 To UBound(wNodeAry)
            If Not (wNodeAry(a).child Is Nothing) Then
                wDescendant = True: Exit For
            End If
        Next
    End If
    IsNodeHas_Brother_Child_Descendant = True
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NodeAllAryInTree(rTrv As TreeView, wNodeAry() As Node) As Boolean
    'c[EChEŜ̃m[h
    Dim nodex As Node
    NodeAllAryInTree = False
    ReDim wNodeAry(0)
    Set nodex = NodeTopsFirst(rTrv.Nodes)
    If nodex Is Nothing Then Exit Function
    Do While Not nodex Is Nothing
        If Not NodeAryParentAndAllDescendant(nodex, wNodeAry()) Then Exit Do
        Set nodex = nodex.Next
    Loop
    NodeAllAryInTree = True
End Function
'**************************************************************************************************
Public Function NodeAryAllTops(rNodes As Nodes, wNodeAry() As Node) As Boolean
    'rNodes ̒gbvm[h𒊏o wNodeAry() ɓ
    Dim a As Long, n As Long
    NodeAryAllTops = False
    ReDim wNodeAry(0)
    For a = 1 To rNodes.count
        If rNodes(a).Parent Is Nothing Then
            n = UBound(wNodeAry) + 1:   ReDim Preserve wNodeAry(n)
            Set wNodeAry(n) = rNodes(a)
        End If
    Next
    If UBound(wNodeAry) > 0 Then NodeAryAllTops = True
End Function
'**************************************************************************************************
Public Function NodeAryAllParents(rNodex As Node, wNodeAry() As Node) As Boolean
    'rNodex ̑SĂ̒n̐e Node  wNodeAry() ɓ
    'rNodex   wNodeAry() ̍ŏɂ͓ĂȂ
    'ret = 1 to UBound()
    Dim nod As Node, ret As Boolean
    NodeAryAllParents = False
    ReDim Preserve wNodeAry(0)
    If rNodex Is Nothing Then Exit Function
    Set nod = rNodex.Parent
    Do While Not (nod Is Nothing)
        ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
        Set wNodeAry(UBound(wNodeAry)) = nod
        Set nod = nod.Parent
    Loop
    NodeAryAllParents = True
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NodeAryAllBrother(rNodex As Node, wNodeAry() As Node) As Boolean
    'rNodex ̑SĂ̌Z Node  wNodeAry() ɓ'
    'ary(1) to ary(n) = FirstSibling to LastSibling
    'rNodex Ԃ̈ʒuɓĂ
    Dim nod As Node, ret As Boolean, node1 As Node
    NodeAryAllBrother = False
    If rNodex Is Nothing Then Exit Function
    Set node1 = rNodex
    Set nod = rNodex.Previous
    Do While Not (nod Is Nothing)
        Set node1 = nod
        Set nod = nod.Previous
    Loop
    ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
    Set wNodeAry(UBound(wNodeAry)) = node1
    Set nod = node1.Next
    Do While Not (nod Is Nothing)
        ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
        Set wNodeAry(UBound(wNodeAry)) = nod
        Set nod = nod.Next
    Loop
    NodeAryAllBrother = True
End Function
'**************************************************************************************************
Public Function NodeAryParentAndAllChild(rNodex As Node, wNodeAry() As Node) As Boolean
    'rNodex   wNodeAry() ̍ŏɂ͂Ă
    'rNodex ̑SĂ̎q Node  wNodeAry() ɓ
    Dim nod As Node, ret As Boolean
    NodeAryParentAndAllChild = False
    If rNodex Is Nothing Then Exit Function
    ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
    Set wNodeAry(UBound(wNodeAry)) = rNodex
    Set nod = rNodex.child
    Do While Not (nod Is Nothing)
        ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
        Set wNodeAry(UBound(wNodeAry)) = nod
        Set nod = nod.Next
    Loop
    NodeAryParentAndAllChild = True
End Function
'**************************************************************************************************
Public Function NodeAryParentAndAllDescendant(rNodex As Node, wNodeAry() As Node) As Boolean
    'rNodex   wNodeAry() ̍ŏɂ͂Ă
    'rNodex ̑SĂ̎q^q Node  wNodeAry() ɓ@'book all node
    Dim nod As Node, ret As Boolean
    NodeAryParentAndAllDescendant = False
    If rNodex Is Nothing Then Exit Function
    ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
    Set wNodeAry(UBound(wNodeAry)) = rNodex
    Set nod = rNodex.child
    Do While Not (nod Is Nothing)
        ret = NodeAryParentAndAllDescendant(nod, wNodeAry())
        Set nod = nod.Next
    Loop
    NodeAryParentAndAllDescendant = True
End Function
'**************************************************************************************************
Public Function NodeAryByOpSelect(op As String, rNodex As Node, wNodeAry() As Node) As Boolean
    NodeAryByOpSelect = False
    If rNodex Is Nothing Then Exit Function
    If op = "one" Then
        ReDim Preserve wNodeAry(UBound(wNodeAry) + 1)
        Set wNodeAry(UBound(wNodeAry)) = rNodex
        NodeAryByOpSelect = True
    ElseIf op = "brother" Then
        NodeAryByOpSelect = NodeAryAllBrother(rNodex, wNodeAry())
    ElseIf op = "parentandchild" Then 'eg wNodeAry() ̍ŏɂ͂Ă
        NodeAryByOpSelect = NodeAryParentAndAllChild(rNodex, wNodeAry())
    ElseIf op = "ParentAndAllDescendant" Then 'eg wNodeAry() ̍ŏɂ͂Ă
        NodeAryByOpSelect = NodeAryParentAndAllDescendant(rNodex, wNodeAry())
    End If
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NodeAryFromCurNextStart(rTree As TreeView, CurNode As Node, Hani As Integer, wNodeAry()) As Boolean
On Error GoTo errop
    Dim a As Long, b As Long, c As Long, m As Long, nodTmp() As Node
    NodeAryFromCurNextStart = False
    ReDim wNodeAry(0)
    If rTree Is Nothing Or CurNode Is Nothing Then Exit Function
    '-----------------------------------------------
    Select Case Hani
    Case 0 '0 = "݂̃猟"
        ReDim wNodeAry(1)
        Set wNodeAry(1) = CurNode
    Case Else
        ReDim nodTmp(0)
        Select Case Hani
        Case 1 '1 = "݂̃ƌZ탁猟"
            If Not NodeAryAllBrother(CurNode, nodTmp()) Then Exit Function
        Case 2 '2 = "݂̖{猟"
            If Not NodeAryParentAndAllDescendant(TopNodeFromDescendantNode(CurNode), nodTmp()) Then Exit Function
        Case 3 '3 = "JĂ{ׂĂ猟"
            If Not NodeAllAryInTree(rTree, nodTmp()) Then Exit Function
        Case Else
            Exit Function
        End Select
        m = UBound(nodTmp)
        ReDim wNodeAry(m)
        For a = 1 To m
            If nodTmp(a) Is CurNode Then
                For b = 1 To m
                    c = a + b
                    If c > m Then c = c - m
                    Set wNodeAry(b) = nodTmp(c)
                Next
                Exit For
            End If
        Next
    End Select
    NodeAryFromCurNextStart = True
Exit Function
errop:
    ReDim wNodeAry(0)
    Exit Function
End Function
'**************************************************************************************************
Public Function NodeExpandAllDescendant(rNodex As Node) As Boolean
    'rNodex ̑SĂ̎qWJ\
    Dim nod As Node, ret As Boolean
    NodeExpandAllDescendant = False
    If rNodex Is Nothing Then Exit Function
    rNodex.Expanded = True
    Set nod = rNodex.child
    Do While Not (nod Is Nothing)
        ret = NodeExpandAllDescendant(nod)
        Set nod = nod.Next
    Loop
    NodeExpandAllDescendant = True
End Function
'**************************************************************************************************
Public Sub TreeNodeSelectByOldPost_IfCurNodeNothing(rTrv As TreeView, rCurKey As String, rForeKey As String, rParentKey As String, rParentsKeys() As String)
    Dim nodex As Node, a As Long
    Set nodex = FindNodeFromKey(rTrv.Nodes, rCurKey)
    If nodex Is Nothing Then
        Set nodex = FindNodeFromKey(rTrv.Nodes, rForeKey)
        If nodex Is Nothing Then Set nodex = FindNodeFromKey(rTrv.Nodes, rParentKey)
        If Not nodex Is Nothing Then
            Set rTrv.SelectedItem = nodex
        ElseIf UBound(rParentsKeys()) > 1 Then
            a = 2 'rParentsKeys(1) = rParentKey
            Do
                Set nodex = FindNodeFromKey(rTrv.Nodes, rParentsKeys(a))
                a = a + 1
            Loop While (nodex Is Nothing) And (a <= UBound(rParentsKeys()))
            If Not nodex Is Nothing Then Set rTrv.SelectedItem = nodex
        End If
    End If
End Sub
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
Public Function NameDoubleCheck(rParent As Node, rAddTitle As String) As Long
    'Return = Double Node Index / 0 = no Double or rParent nothing  / -10 = rAddTitle = ""
    Dim s As String, a As Long, wNodeAry() As Node
    NameDoubleCheck = -10
    s = UCase$(Trim$(rAddTitle))
    If s = "" Then Exit Function
    ReDim wNodeAry(0)
    If NodeAryParentAndAllChild(rParent, wNodeAry()) Then
        For a = 2 To UBound(wNodeAry)
            If UCase$(wNodeAry(a).Text) = s Then
                NameDoubleCheck = wNodeAry(a).Index
                Exit Function
            End If
        Next
    End If
    NameDoubleCheck = 0
End Function
'**************************************************************************************************
Public Sub NameDoubleCheckAryMake(rParent As Node, wNodeAry() As Node)
    ReDim wNodeAry(0)
    Call NodeAryParentAndAllChild(rParent, wNodeAry())
End Sub
'**************************************************************************************************
Public Function NameDoubleCheckByAry(wNodeAry() As Node, rAddTitle As String) As Long
    'Return = Double Node Index / 0 = no Double or rParent nothing  / -10 = rAddTitle = ""
    Dim s As String, a As Long
    NameDoubleCheckByAry = -10
    s = UCase$(Trim$(rAddTitle))
    If s = "" Then Exit Function
    For a = 2 To UBound(wNodeAry)
        If UCase$(wNodeAry(a).Text) = s Then
            NameDoubleCheckByAry = wNodeAry(a).Index
            Exit Function
        End If
    Next
    NameDoubleCheckByAry = 0
End Function
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************


